<?php
/*
Plugin Name: Related Posts via Categories
Plugin URI: http://alphasis.info/developments/wordpress-plugins/related-posts-via-categories/
Description: This Plugin will generate a related posts via categories. It can automatically display related posts after the content on the single post page. This plugins works when any single post page is being displayed. This plugin requires the tag introduced in WordPress Version 3.0.
Version: 1.1.1
Author: alphasis
Author URI: http://alphasis.info/
*/

/*
Copyright 2010  alphasis  (http://alphasis.info/)
*/

/*
Display
*/

add_filter('the_content', 'add_filter_related_posts_via_categories', 88);

function add_filter_related_posts_via_categories($content) {
	$rpvc_data = get_option("related_posts_via_categories");
	if( $rpvc_data['auto_display'] == 'yes' and is_singular('post') ){ 
		$output = related_posts_via_categories();
		$content = $content . $output;
	}
	return $content;
}

function display_related_posts_via_categories() {
	if( is_singular('post') ){ 
		$output = related_posts_via_categories();
		echo $output;
	}
}

function related_posts_via_categories() {
	$rpvc_data = get_option("related_posts_via_categories");
	$title = stripslashes( "$rpvc_data[related_posts_title]" );
	$wrap_before = stripslashes( "$rpvc_data[before_related_posts_title_and_related_posts]" );
	$wrap_after = "$rpvc_data[after_related_posts_title_and_related_posts]";
	$before_title = stripslashes( "$rpvc_data[before_related_posts_title]" );
	$after_title = "$rpvc_data[after_related_posts_title]";
	$before_entries = stripslashes( "$rpvc_data[before_related_posts]" );
	$after_entries = "$rpvc_data[after_related_posts]";
	$before_entry = stripslashes( "$rpvc_data[before_each_related_post]" );
	$after_entry = "$rpvc_data[after_each_related_post]";
	$number_of_posts_to_show = "$rpvc_data[maximum_number_of_related_posts]";
	$extraction_number_of_posts_from_category = "$rpvc_data[extraction_number_of_posts_from_category]";
	$order_by = "$rpvc_data[order_by]";
	$exclude_posts = "$rpvc_data[exclude_posts]";
	$exclude_posts .= ',' . get_the_ID();
	$exclude_categories = explode (",", "$rpvc_data[exclude_categories]");
	if (!$number_of_posts_to_show) { $number_of_posts_to_show = 10;}
	if (!$extraction_number_of_posts_from_category) { $extraction_number_of_posts_from_category = 300;}

	$posts = array();
	foreach ( (get_the_category()) as $category ) {
		$cat_ID = $category->cat_ID;
		foreach ( $exclude_categories as $exclude_category ) {
			if( $cat_ID == $exclude_category ){ continue 2; }
		}
		if( $category->count <= 1 ){ continue; }
		$postslist = get_posts("category=$cat_ID&numberposts=$extraction_number_of_posts_from_category&exclude=$exclude_posts&post_type=post");
		foreach ( $postslist as $post ) {
			array_push ( $posts, "$post->ID" );
			$post_date_1[$post->ID] = $post->post_date;
			$post_modified_1[$post->ID] = $post->post_modified;
		}
	}
	if($posts) {
		$related_scores = array_count_values ( $posts );
	
		foreach ($related_scores as $key => $value) {
			$related_score_1[$key] =  "$value";
			$posts_data[] = array('post_id' => "$key", 'post_date' => "$post_date_1[$key]", 'post_modified' => "$post_modified_1[$key]", 'related_score' => "$related_score_1[$key]");
		}
		foreach ($posts_data as $key => $row) {
			$post_id[$key]  = $row['post_id'];
			$post_date[$key] = $row['post_date'];
			$post_modified[$key] = $row['post_modified'];
			$related_score[$key] = $row['related_score'];
		}
		if ( $order_by == "related_scores_high__date_published_old" ){
			array_multisort($related_score, SORT_DESC, $post_date, SORT_ASC, $post_id, SORT_ASC, $post_modified, SORT_ASC, $posts_data);
		} elseif ( $order_by == "related_scores_low__date_published_new" ) {
			array_multisort($related_score, SORT_ASC, $post_date, SORT_DESC, $post_id, SORT_DESC, $post_modified, SORT_DESC, $posts_data);
		} elseif ( $order_by == "related_scores_low__date_published_old" ) {
			array_multisort($related_score, SORT_ASC, $post_date, SORT_ASC, $post_id, SORT_ASC, $post_modified, SORT_ASC, $posts_data);
		} elseif ( $order_by == "related_scores_high__date_modified_new" ) {
			array_multisort($related_score, SORT_DESC, $post_modified, SORT_DESC, $post_date, SORT_DESC, $post_id, SORT_DESC, $posts_data);
		} elseif ( $order_by == "related_scores_high__date_modified_old" ) {
			array_multisort($related_score, SORT_DESC, $post_modified, SORT_ASC, $post_date, SORT_ASC, $post_id, SORT_ASC, $posts_data);
		} elseif ( $order_by == "related_scores_low__date_modified_new" ) {
			array_multisort($related_score, SORT_ASC, $post_modified, SORT_DESC, $post_date, SORT_DESC, $post_id, SORT_DESC, $posts_data);
		} elseif ( $order_by == "related_scores_low__date_modified_old" ) {
			array_multisort($related_score, SORT_ASC, $post_modified, SORT_ASC, $post_date, SORT_ASC, $post_id, SORT_ASC, $posts_data);
		} elseif ( $order_by == "date_published_new" ) {
			array_multisort($post_date, SORT_DESC, $post_id, SORT_DESC, $post_modified, SORT_DESC, $related_score, SORT_DESC, $posts_data);
		} elseif ( $order_by == "date_published_old" ) {
			array_multisort($post_date, SORT_ASC, $post_id, SORT_ASC, $post_modified, SORT_ASC, $related_score, SORT_DESC, $posts_data);
		} elseif ( $order_by == "date_modified_new" ) {
			array_multisort($post_modified, SORT_DESC, $post_date, SORT_DESC, $post_id, SORT_DESC, $related_score, SORT_DESC, $posts_data);
		} elseif ( $order_by == "date_modified_old" ) {
			array_multisort($post_modified, SORT_ASC, $post_date, SORT_ASC, $post_id, SORT_ASC, $related_score, SORT_DESC, $posts_data);
		} else {
			array_multisort($related_score, SORT_DESC, $post_date, SORT_DESC, $post_id, SORT_DESC, $post_modified, SORT_DESC, $posts_data);
		}
		if( $title ){ $title = $before_title . $title . $after_title; }
		$count =''; $entries ='';
		foreach ( $posts_data as $key => $value ) {
			$count++;
			if( $count > $number_of_posts_to_show ){ break; };
			$entries .= $before_entry . '<a href="' . get_permalink($post_id[$key]) . '" title="' . get_the_title($post_id[$key]) . '">' . get_the_title($post_id[$key]) . '</a>' ;
			if ( is_user_logged_in() ) { $entries .= " ($related_score[$key])"; }
			$entries .=  $after_entry ;
		}
		$output = $wrap_before.$title.$before_entries.$entries.$after_entries.$wrap_after;
	}else{
		$output = "";
	}
	return $output;
}

/*
Option
*/

add_action('admin_menu', 'add_action_related_posts_via_categories');

function add_action_related_posts_via_categories() {
	add_options_page(__('Related Posts via Categories','related-posts-via-categories'), __('Related Posts via Categories','related-posts-via-categories'), 'manage_options', basename(__FILE__), 'option_of_related_posts_via_categories');
}

function option_of_related_posts_via_categories() {
	$rpvc_data = get_option("related_posts_via_categories");
	$message = '';
	if ( $_POST['submit'] ) {
		$rpvc_post = array (
			"auto_display" => trim($_POST['auto_display']),
			"maximum_number_of_related_posts" => trim($_POST['maximum_number_of_related_posts']),
			"related_posts_title" => trim($_POST['related_posts_title']),
			"before_related_posts_title_and_related_posts" => trim($_POST['before_related_posts_title_and_related_posts']),
			"after_related_posts_title_and_related_posts" => trim($_POST['after_related_posts_title_and_related_posts']),
			"before_related_posts_title" => trim($_POST['before_related_posts_title']),
			"after_related_posts_title" => trim($_POST['after_related_posts_title']),
			"before_related_posts" => trim($_POST['before_related_posts']),
			"after_related_posts" => trim($_POST['after_related_posts']),
			"before_each_related_post" => trim($_POST['before_each_related_post']),
			"after_each_related_post" => trim($_POST['after_each_related_post']),
			"exclude_posts" => trim($_POST['exclude_posts']),
			"exclude_categories" => trim($_POST['exclude_categories']),
			"extraction_number_of_posts_from_category" => trim($_POST['extraction_number_of_posts_from_category']),
			"order_by" => trim($_POST['order_by']),
		);
		if ($rpvc_data != $rpvc_post) {
			if(!update_option("related_posts_via_categories",$rpvc_post)) {
				$message = __("Updated Failed",'related-posts-via-categories');
			}else{
				$message = __("Updated",'related-posts-via-categories');
				$rpvc_data = get_option("related_posts_via_categories");
			}
		}
	}
	$rpvc_data['related_posts_title'] = stripslashes( $rpvc_data['related_posts_title'] );
	$rpvc_data['before_related_posts_title_and_related_posts'] = stripslashes( $rpvc_data['before_related_posts_title_and_related_posts'] );
	$rpvc_data['before_related_posts_title'] = stripslashes( $rpvc_data['before_related_posts_title'] );
	$rpvc_data['before_related_posts'] = stripslashes( $rpvc_data['before_related_posts'] );
	$rpvc_data['before_each_related_post'] = stripslashes( $rpvc_data['before_each_related_post'] );
	?>
	<script>
	<!--
	jQuery( function() {
		jQuery( 'input[name=related_posts_title]' ) . val( '<?php echo $rpvc_data['related_posts_title'] ?>' );
		jQuery( 'input[name=before_related_posts_title_and_related_posts]' ) . val( '<?php echo $rpvc_data['before_related_posts_title_and_related_posts'] ?>' );
		jQuery( 'input[name=before_related_posts_title]' ) . val( '<?php echo $rpvc_data['before_related_posts_title'] ?>' );
		jQuery( 'input[name=before_related_posts]' ) . val( '<?php echo $rpvc_data['before_related_posts'] ?>' );
		jQuery( 'input[name=before_each_related_post]' ) . val( '<?php echo $rpvc_data['before_each_related_post'] ?>' );
	} );
	// -->
	</script>
	<div class="wrap">
		<h2><?php _e('Related Posts via Categories - Settings','related-posts-via-categories') ?></h2>
		<ul>
			<li><a href="https://www.paypal.com/cgi-bin/webscr?cmd=_s-xclick&hosted_button_id=JQCM6H5BSMZSY" target="_blank"><?php _e('Please pay if you like "Related Posts via Categories".', 'related-posts-via-categories'); ?></a></li>
			<li><?php _e("Official page",'related-posts-via-categories'); ?> : <a href="http://alphasis.info/developments/wordpress-plugins/related-posts-via-categories/" target="_blank"><?php _e("English",'related-posts-via-categories'); ?></a> / <a href="http://alphasis.info/2011/02/related-posts-via-categories/" target="_blank"><?php _e("Japanese",'related-posts-via-categories'); ?></a></li>
		</ul>
		<div class="message"><p><?php echo $message; ?></p></div>
		<form method="post" action="<?php echo $_SERVER['PHP_SELF']; ?>?page=<?php echo basename(__FILE__); ?>">
		<h3><?php _e('Display Settings','related-posts-via-categories') ?></h3>
			<table class="form-table">
				<tr valign="top">
					<th scope="row"><?php _e("Auto display",'related-posts-via-categories'); ?>:</th>
					<td>
						<input type="checkbox" name="auto_display" value="yes" <?php if( $rpvc_data['auto_display'] ){ echo " checked"; } ?> />
						<?php _e('This option automatically displays related posts after the content on the single post page.','related-posts-via-categories'); ?>
						<br /><?php _e('If this option is off, you will need to manually insert "display_related_posts_via_categories()" into your theme files.','related-posts-via-categories'); ?>
					</td>
				</tr>
				<tr valign="top">
					<th scope="row"><?php _e("Maximum number of related posts",'related-posts-via-categories'); ?>:</th>
					<td>
						<input type="text" name="maximum_number_of_related_posts" value="<?php echo $rpvc_data['maximum_number_of_related_posts']; ?>" size="2" />
						<?php _e('If you do not enter anything','related-posts-via-categories'); echo ': 10'; ?>
					</td>
				</tr>
				<tr valign="top">
					<th scope="row"><?php _e("Related posts title",'related-posts-via-categories'); ?>:</th>
					<td>
						<input type="text" name="related_posts_title" size="50" />
						<?php _e('For example','related-posts-via-categories'); echo ': '; _e('Related Posts'); ?>
					</td>
				</tr>
				<tr valign="top">
					<th scope="row"><?php _e("Before related posts title and related posts",'related-posts-via-categories'); ?>:</th>
					<td>
						<input type="text" name="before_related_posts_title_and_related_posts" size="50" />
						<?php _e('For example','related-posts-via-categories'); echo ': &lt;div id=&#34;related-posts-via-categories&#34;&gt;'; ?>
					</td>
				</tr>
				<tr valign="top">
					<th scope="row"><?php _e("After related posts title and related posts",'related-posts-via-categories'); ?>:</th>
					<td>
						<input type="text" name="after_related_posts_title_and_related_posts" value="<?php echo $rpvc_data['after_related_posts_title_and_related_posts']; ?>" />
						<?php _e('For example','related-posts-via-categories'); echo ': &lt;/div&gt;'; ?>
					</td>
				</tr>
				<tr valign="top">
					<th scope="row"><?php _e("Before related posts title",'related-posts-via-categories'); ?>:</th>
					<td>
						<input type="text" name="before_related_posts_title" size="50" />
						<?php _e('For example','related-posts-via-categories'); echo ': &lt;h2 id=&#34;related-posts-via-categories-title&#34;&gt;'; ?>
					</td>
				</tr>
				<tr valign="top">
					<th scope="row"><?php _e("After related posts title",'related-posts-via-categories'); ?>:</th>
					<td>
						<input type="text" name="after_related_posts_title" value="<?php echo $rpvc_data['after_related_posts_title']; ?>" />
						<?php _e('For example','related-posts-via-categories'); echo ': &lt;/h2&gt;'; ?>
					</td>
				</tr>
				<tr valign="top">
					<th scope="row"><?php _e("Before related posts",'related-posts-via-categories'); ?>:</th>
					<td>
						<input type="text" name="before_related_posts" size="50" />
						<?php _e('For example','related-posts-via-categories'); echo ': &lt;ul id=&#34;related-posts-via-categories-list&#34;&gt;'; ?>
					</td>
				</tr>
				<tr valign="top">
					<th scope="row"><?php _e("After related posts",'related-posts-via-categories'); ?>:</th>
					<td>
						<input type="text" name="after_related_posts" value="<?php echo $rpvc_data['after_related_posts']; ?>" />
						<?php _e('For example','related-posts-via-categories'); echo ': &lt;/ul&gt;'; ?>
					</td>
				</tr>
				<tr valign="top">
					<th scope="row"><?php _e("Before each related post",'related-posts-via-categories'); ?>:</th>
					<td>
						<input type="text" name="before_each_related_post" size="50" />
						<?php _e('For example','related-posts-via-categories'); echo ': &lt;li class=&#34;related-posts-via-categories-item&#34;&gt;'; ?>
					</td>
				</tr>
				<tr valign="top">
					<th scope="row"><?php _e("After each related post",'related-posts-via-categories'); ?>:</th>
					<td>
						<input type="text" name="after_each_related_post" value="<?php echo $rpvc_data['after_each_related_post']; ?>" />
						<?php _e('For example','related-posts-via-categories'); echo ': &lt;/li&gt;'; ?>
					</td>
				</tr>
			</table>
		<h3><?php _e('Other Settings','related-posts-via-categories') ?></h3>
			<table class="form-table">
				<tr valign="top">
					<th scope="row"><?php _e('Order By', 'related-posts-via-categories'); ?>:</th>
					<td>
					<input id="related_scores_high__date_published_new" name="order_by" type="radio" value="related_scores_high__date_published_new"<?php if($rpvc_data['order_by']=="related_scores_high__date_published_new")echo ' checked'; ?> /><label for="related_scores_high__date_published_new"><?php _e(' Related Scores : High', 'related-posts-via-categories'); ?>&nbsp;&nbsp;/&nbsp;<?php _e(' Date Published : New', 'related-posts-via-categories'); ?>&nbsp;&nbsp;(&nbsp;<?php _e('Default setting', 'related-posts-via-categories'); ?>&nbsp;)</label>
					<br /><input id="related_scores_high__date_published_old" name="order_by" type="radio" value="related_scores_high__date_published_old"<?php if($rpvc_data['order_by']=="related_scores_high__date_published_old")echo ' checked'; ?> /><label for="related_scores_high__date_published_old"><?php _e(' Related Scores : High', 'related-posts-via-categories'); ?>&nbsp;&nbsp;/&nbsp;<?php _e(' Date Published : Old', 'related-posts-via-categories'); ?></label>
					<br /><input id="related_scores_low__date_published_new" name="order_by" type="radio" value="related_scores_low__date_published_new"<?php if($rpvc_data['order_by']=="related_scores_low__date_published_new")echo ' checked'; ?> /><label for="related_scores_low__date_published_new"><?php _e(' Related Scores : Low', 'related-posts-via-categories'); ?>&nbsp;&nbsp;/&nbsp;<?php _e(' Date Published : New', 'related-posts-via-categories'); ?></label>
					<br /><input id="related_scores_low__date_published_old" name="order_by" type="radio" value="related_scores_low__date_published_old"<?php if($rpvc_data['order_by']=="related_scores_low__date_published_old")echo ' checked'; ?> /><label for="related_scores_low__date_published_old"><?php _e(' Related Scores : Low', 'related-posts-via-categories'); ?>&nbsp;&nbsp;/&nbsp;<?php _e(' Date Published : Old', 'related-posts-via-categories'); ?></label>
					<br /><input id="related_scores_high__date_modified_new" name="order_by" type="radio" value="related_scores_high__date_modified_new"<?php if($rpvc_data['order_by']=="related_scores_high__date_modified_new")echo ' checked'; ?> /><label for="related_scores_high__date_modified_new"><?php _e(' Related Scores : High', 'related-posts-via-categories'); ?>&nbsp;&nbsp;/&nbsp;<?php _e(' Date Modified : New', 'related-posts-via-categories'); ?></label>
					<br /><input id="related_scores_high__date_modified_old" name="order_by" type="radio" value="related_scores_high__date_modified_old"<?php if($rpvc_data['order_by']=="related_scores_high__date_modified_old")echo ' checked'; ?> /><label for="related_scores_high__date_modified_old"><?php _e(' Related Scores : High', 'related-posts-via-categories'); ?>&nbsp;&nbsp;/&nbsp;<?php _e(' Date Modified : Old', 'related-posts-via-categories'); ?></label>
					<br /><input id="related_scores_low__date_modified_new" name="order_by" type="radio" value="related_scores_low__date_modified_new"<?php if($rpvc_data['order_by']=="related_scores_low__date_modified_new")echo ' checked'; ?> /><label for="related_scores_low__date_modified_new"><?php _e(' Related Scores : Low', 'related-posts-via-categories'); ?>&nbsp;&nbsp;/&nbsp;<?php _e(' Date Modified : New', 'related-posts-via-categories'); ?></label>
					<br /><input id="related_scores_low__date_modified_old" name="order_by" type="radio" value="related_scores_low__date_modified_old"<?php if($rpvc_data['order_by']=="related_scores_low__date_modified_old")echo ' checked'; ?> /><label for="related_scores_low__date_modified_old"><?php _e(' Related Scores : Low', 'related-posts-via-categories'); ?>&nbsp;&nbsp;/&nbsp;<?php _e(' Date Modified : Old', 'related-posts-via-categories'); ?></label>
					<br /><input id="date_published_new" name="order_by" type="radio" value="date_published_new"<?php if($rpvc_data['order_by']=="date_published_new")echo ' checked'; ?> /><label for="date_published_new"><?php _e(' Date Published : New', 'related-posts-via-categories'); ?></label>
					<br /><input id="date_published_old" name="order_by" type="radio" value="date_published_old"<?php if($rpvc_data['order_by']=="date_published_old")echo ' checked'; ?> /><label for="date_published_old"><?php _e(' Date Published : Old', 'related-posts-via-categories'); ?></label>
					<br /><input id="date_modified_new" name="order_by" type="radio" value="date_modified_new"<?php if($rpvc_data['order_by']=="date_modified_new")echo ' checked'; ?> /><label for="date_modified_new"><?php _e(' Date Modified : New', 'related-posts-via-categories'); ?></label>
					<br /><input id="date_modified_old" name="order_by" type="radio" value="date_modified_old"<?php if($rpvc_data['order_by']=="date_modified_old")echo ' checked'; ?> /><label for="date_modified_old"><?php _e(' Date Modified : Old', 'related-posts-via-categories'); ?></label>
					</td>
				</tr>
				<tr valign="top">
					<th scope="row"><?php _e("Exclude (Posts)",'related-posts-via-categories'); ?>:</th>
					<td>
						<input type="text" name="exclude_posts" value="<?php echo $rpvc_data['exclude_posts']; ?>" size="50" />
						<?php _e('The IDs of any posts you want to exclude, separated by commas.','related-posts-via-categories'); ?>
					</td>
				</tr>
				<tr valign="top">
					<th scope="row"><?php _e("Exclude (Categories)",'related-posts-via-categories'); ?>:</th>
					<td>
						<input type="text" name="exclude_categories" value="<?php echo $rpvc_data['exclude_categories']; ?>" size="50" />
						<?php _e('The IDs of any categories you want to exclude, separated by commas.','related-posts-via-categories'); ?>
					</td>
				</tr>
				<tr valign="top">
					<th scope="row"><?php _e("Maximum extraction number",'related-posts-via-categories'); ?>:</th>
					<td>
						<input type="text" name="extraction_number_of_posts_from_category" value="<?php echo $rpvc_data['extraction_number_of_posts_from_category']; ?>" size="3" />
						<?php _e('If you do not enter anything','related-posts-via-categories'); ?>: 300
						<br /><?php _e('The maximum extraction number of posts from the each category.','related-posts-via-categories'); ?>
					</td>
				</tr>
			</table>
			<p class="submit">
			<input type="submit" class="button-primary" value="<?php _e('Save changes','related-posts-via-categories') ?>" name="submit" />
			</p>
		
		</form>
	</div>
	<?php
}

/*
Register
*/

register_activation_hook( __FILE__, 'activate_related_posts_via_categories' );

function activate_related_posts_via_categories() {
	$rpvc_post = array (
		"auto_display" => "yes",
		"maximum_number_of_related_posts" => "10",
		"related_posts_title" => "Related Posts via Categories",
		"before_related_posts_title_and_related_posts" => "",
		"after_related_posts_title_and_related_posts" => "",
		"before_related_posts_title" => "<h2 id=\"related-posts-via-categories-title\">",
		"after_related_posts_title" => "</h2>",
		"before_related_posts" => "<ul id=\"related-posts-via-categories-list\">",
		"after_related_posts" => "</ul>",
		"before_each_related_post" => "<li>",
		"after_each_related_post" => "</li>",
		"exclude_posts" => "",
		"exclude_categories" => "",
		"extraction_number_of_posts_from_category" => "300",
		"order_by" => "related_scores_high__date_published_new",
	);
	update_option("related_posts_via_categories",$rpvc_post);
}

load_plugin_textdomain( 'related-posts-via-categories', false, 'related-posts-via-categories/languages' );

?>
